import { world, system } from '@minecraft/server';

import { CHAT_COOLDOWN } from './config.js';

export const COOLDOWNS = {};

world.afterEvents.playerLeave.subscribe(({ playerId, playerName }) => {
	if (!COOLDOWNS[playerId]) return;
	delete COOLDOWNS[playerId];
});

export function isAbleToSend(playerId) {
	return !(COOLDOWNS[playerId] >= Date.now());
}

export function getCooldown(playerId) {
	return COOLDOWNS[playerId];
}

export function getFormatedCooldown(playerId) {
	if (!COOLDOWNS[playerId]) return 0;
	return Math.ceil((COOLDOWNS[playerId] - Date.now()) / 100) / 10;
}

export function setCooldown(playerId) {
	COOLDOWNS[playerId] = Date.now() + CHAT_COOLDOWN * 1000;
}

export function handleCooldown(playerId) {
	const canSend = isAbleToSend(playerId);
	if (canSend) setCooldown(playerId);
	return canSend;
}
